library(plyr)
library(dplyr)

csv.combine <- function(fdir, csv_tfiles,
                        final_csv = "test_final.csv"){
    rtable <- read.table(csv_tfiles[1], header = T, as.is = T)
    write.table(t(rtable), final_csv, row.names = T, col.names = T, quote = F)
    mdim <- dim(rtable)
    for(i in 2:3) {
        rtable <- read.table(csv_tfiles[i], header = T, as.is = T)
        stopifnot(dim(rtable)[1] == mdim[1])
        write.table(t(rtable), final_csv, row.names = T, col.names = F, quote = F,
                    append = T)
    }
    rtable
}

copy.mas.files <- function(did, dest_prefix,
                           cel_images_metadata,
                           dest_dir = "test"){
    access_name <- did
    db_source <- cel_images_metadata[ cel_images_metadata$Access %in% did, "Database" ][1]
    src_base_name1 <- paste(access_name, "mas5.csv", sep = ".")
    src_file1 <- paste(final_root_dir,
                      db_source, access_name, src_base_name1, sep = "/")
    dest_base_name1 <- paste (dest_prefix, access_name, ".mas5.csv", sep = "")
    dest_file1 <- paste(final_root_dir, "test", dest_base_name1, sep = "/")
    src_base_name2 <- paste(access_name, "log2.csv", sep = ".")
    src_file2 <- paste(final_root_dir,
                      db_source, access_name, src_base_name2, sep = "/")
    dest_base_name2 <- paste (dest_prefix, access_name, ".log2.csv", sep = "")
    dest_file2 <- paste(final_root_dir, dest_dir, dest_base_name2, sep = "/")
    rv1 <- file.copy(from = src_file1, to = dest_file1)
    rv2 <- file.copy(from = src_file2, to = dest_file2)
    c(access_name, rv1, rv2)
}

copy.norm.file <- function(did, src_dir = "C:/data/arrays/final/jaric",
                            dest_dir = "C:/data/arrays/final/normalize/",
                            dest_prefix = "SR_"){
    src_file <- paste(src_dir, did, sep = "/")
    dest_file <- paste(dest_dir, dest_prefix, did, sep = "")
    print(dest_file)
    rv <- file.copy(from = src_file, to = dest_file)
    c(did, rv)
}

count.cels.log2 <- function(source_dir = "c:/data/arrays/final/normalize"){
  csv_files <- dir(source_dir, "*.log2.csv", full.names = T)
  ldply(csv_files, function(cfn){
      rtable <- read.table(cfn, header = T, as.is = T)
      c(cfn, length(colnames(rtable)))
  })
}
