source("normalize_exp.R")
gen_samples <- function(csv.fname, nsamples, ndata, fname.prefix){
    edata <- read.table(csv.fname, row.names = 1, head = T)
    ematrix <- as.matrix(edata)
    tsamp <- sample(1:(dim(edata)[2]), nsamples * ndata)
    for(i in 1:nsamples){
        scols <- tsamp[(1 + (i - 1) * ndata):(i * ndata)]
        Midx <- qn_iqr_dry_auto(ematrix, scols)
        M0 <- normalizeBetweenArrays(ematrix[Midx$idx, scols], method="quantile")
        fname <- paste(fname.prefix, i, ".csv", sep="")
        write.table(file=fname, M0, row.names=TRUE, col.names=TRUE,
                    sep="\t", quote=FALSE)
   }
}


args <- commandArgs(TRUE)
print(args)
csv.fname <- args[1]
nsamples <- as.integer(args[2])
ndata <- as.integer(args[3])
fname.prefix <- args[4]
gen_samples(csv.fname, nsamples, ndata, fname.prefix)
